diff -ruN linux-2.6.15.6/ipc/msg.c linux-2.6.15.6-cher1/ipc/msg.c
--- linux-2.6.15.6/ipc/msg.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/ipc/msg.c	2006-03-06 18:21:11.000000000 +0300
@@ -207,6 +207,9 @@
 	int id, ret = -EPERM;
 	struct msg_queue *msq;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	down(&msg_ids.sem);
 	if (key == IPC_PRIVATE) 
 		ret = newque(key, msgflg);
@@ -333,6 +336,9 @@
 	struct msq_setbuf setbuf;
 	struct kern_ipc_perm *ipcp;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (msqid < 0 || cmd < 0)
 		return -EINVAL;
 
@@ -558,6 +564,9 @@
 	long mtype;
 	int err;
 	
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (msgsz > msg_ctlmax || (long) msgsz < 0 || msqid < 0)
 		return -EINVAL;
 	if (get_user(mtype, &msgp->mtype))
@@ -670,6 +679,9 @@
 	struct msg_msg *msg;
 	int mode;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (msqid < 0 || (long) msgsz < 0)
 		return -EINVAL;
 	mode = convert_mode(&msgtyp,msgflg);
@@ -832,3 +844,9 @@
 			  msq->q_ctime);
 }
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/ipc/sem.c linux-2.6.15.6-cher1/ipc/sem.c
--- linux-2.6.15.6/ipc/sem.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/ipc/sem.c	2006-03-06 18:18:15.000000000 +0300
@@ -211,6 +211,9 @@
 	int id, err = -EINVAL;
 	struct sem_array *sma;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (nsems < 0 || nsems > sc_semmsl)
 		return -EINVAL;
 	down(&sem_ids.sem);
@@ -862,6 +865,9 @@
 	int err = -EINVAL;
 	int version;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (semid < 0)
 		return -EINVAL;
 
@@ -1060,6 +1066,9 @@
 	struct sem_queue queue;
 	unsigned long jiffies_left = 0;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (nsops < 1 || semid < 0)
 		return -EINVAL;
 	if (nsops > sc_semopm)
@@ -1350,3 +1359,9 @@
 			  sma->sem_ctime);
 }
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/ipc/shm.c linux-2.6.15.6-cher1/ipc/shm.c
--- linux-2.6.15.6/ipc/shm.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/ipc/shm.c	2006-03-06 18:11:41.000000000 +0300
@@ -263,6 +263,9 @@
 	struct shmid_kernel *shp;
 	int err, id = 0;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	down(&shm_ids.sem);
 	if (key == IPC_PRIVATE) {
 		err = newseg(key, shmflg, size);
@@ -421,6 +424,9 @@
 	struct shmid_kernel *shp;
 	int err, version;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (cmd < 0 || shmid < 0) {
 		err = -EINVAL;
 		goto out;
@@ -788,6 +794,9 @@
 	unsigned long ret;
 	long err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	err = do_shmat(shmid, shmaddr, shmflg, &ret);
 	if (err)
 		return err;
@@ -807,6 +816,9 @@
 	loff_t size = 0;
 	int retval = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	down_write(&mm->mmap_sem);
 
 	/*
@@ -909,3 +921,9 @@
 			  shp->shm_ctim);
 }
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/acct.c linux-2.6.15.6-cher1/kernel/acct.c
--- linux-2.6.15.6/kernel/acct.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/acct.c	2006-03-06 12:09:05.000000000 +0300
@@ -252,6 +252,9 @@
 {
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!capable(CAP_SYS_PACCT))
 		return -EPERM;
 
@@ -602,3 +605,9 @@
 		tsk->acct_vm_mem1 = 0;
 	}
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/capability.c linux-2.6.15.6-cher1/kernel/capability.c
--- linux-2.6.15.6/kernel/capability.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/capability.c	2006-03-06 12:09:05.000000000 +0300
@@ -48,6 +48,9 @@
      task_t *target;
      struct __user_cap_data_struct data;
 
+     if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+             return -EPERM;
+
      if (get_user(version, &header->version))
 	     return -EFAULT;
 
@@ -175,6 +178,9 @@
      int ret;
      pid_t pid;
 
+     if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+             return -EPERM;
+
      if (get_user(version, &header->version))
 	     return -EFAULT; 
 
@@ -232,3 +238,9 @@
 
      return ret;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/compat.c linux-2.6.15.6-cher1/kernel/compat.c
--- linux-2.6.15.6/kernel/compat.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/compat.c	2006-03-13 13:07:57.000000000 +0300
@@ -268,6 +268,9 @@
 	int ret;
 	mm_segment_t old_fs = get_fs ();
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (resource >= RLIM_NLIMITS) 
 		return -EINVAL;	
 
@@ -387,6 +390,9 @@
 compat_sys_wait4(compat_pid_t pid, compat_uint_t __user *stat_addr, int options,
 	struct compat_rusage __user *ru)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!ru) {
 		return sys_wait4(pid, stat_addr, options, NULL);
 	} else {
@@ -421,6 +427,9 @@
 	long ret;
 	mm_segment_t old_fs = get_fs();
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	memset(&info, 0, sizeof(info));
 
 	set_fs(KERNEL_DS);
@@ -463,6 +472,9 @@
 	cpumask_t new_mask;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = compat_get_user_cpu_mask(user_mask_ptr, len, &new_mask);
 	if (retval)
 		return retval;
@@ -478,6 +490,9 @@
 	unsigned long *k;
 	unsigned int min_length = sizeof(cpumask_t);
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (NR_CPUS <= BITS_PER_COMPAT_LONG)
 		min_length = sizeof(compat_ulong_t);
 
@@ -522,6 +537,9 @@
 	mm_segment_t oldfs;
 	struct itimerspec newts, oldts;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!new)
 		return -EINVAL;
 	if (get_compat_itimerspec(&newts, new))
@@ -544,6 +562,9 @@
 	mm_segment_t oldfs;
 	struct itimerspec ts; 
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_timer_gettime(timer_id,
@@ -561,6 +582,9 @@
 	mm_segment_t oldfs;
 	struct timespec ts; 
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (get_compat_timespec(&ts, tp))
 		return -EFAULT; 
 	oldfs = get_fs();
@@ -578,6 +602,9 @@
 	mm_segment_t oldfs;
 	struct timespec ts; 
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_clock_gettime(which_clock,
@@ -595,6 +622,9 @@
 	mm_segment_t oldfs;
 	struct timespec ts; 
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	oldfs = get_fs();
 	set_fs(KERNEL_DS);
 	err = sys_clock_getres(which_clock,
@@ -613,6 +643,9 @@
 	mm_segment_t oldfs;
 	struct timespec in, out; 
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (get_compat_timespec(&in, rqtp)) 
 		return -EFAULT;
 
@@ -841,6 +874,9 @@
 	struct timespec tv;
 	int err;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (get_user(tv.tv_sec, tptr))
 		return -EFAULT;
 
@@ -855,3 +891,9 @@
 }
 
 #endif /* __ARCH_WANT_COMPAT_SYS_TIME */
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/exec_domain.c linux-2.6.15.6-cher1/kernel/exec_domain.c
--- linux-2.6.15.6/kernel/exec_domain.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/exec_domain.c	2006-03-06 12:09:05.000000000 +0300
@@ -194,6 +194,9 @@
 {
 	u_long old = current->personality;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return (long) old;
+
 	if (personality != 0xffffffff) {
 		set_personality(personality);
 		if (current->personality != personality)
@@ -207,3 +210,9 @@
 EXPORT_SYMBOL(register_exec_domain);
 EXPORT_SYMBOL(unregister_exec_domain);
 EXPORT_SYMBOL(__set_personality);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/exit.c linux-2.6.15.6-cher1/kernel/exit.c
--- linux-2.6.15.6/kernel/exit.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/exit.c	2006-03-06 12:09:05.000000000 +0300
@@ -1115,7 +1115,7 @@
 	status = (p->signal->flags & SIGNAL_GROUP_EXIT)
 		? p->signal->group_exit_code : p->exit_code;
 	if (!retval && stat_addr)
-		retval = put_user(status, stat_addr);
+		retval = put_user(status | (((p->flags & PF_MEMLIMITERR))?0x10000:0), stat_addr);
 	if (!retval && infop)
 		retval = put_user(SIGCHLD, &infop->si_signo);
 	if (!retval && infop)
@@ -1517,6 +1517,9 @@
 {
 	long ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (options & ~(WNOHANG|WNOWAIT|WEXITED|WSTOPPED|WCONTINUED))
 		return -EINVAL;
 	if (!(options & (WEXITED|WSTOPPED|WCONTINUED)))
@@ -1551,6 +1554,9 @@
 {
 	long ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (options & ~(WNOHANG|WUNTRACED|WCONTINUED|
 			__WNOTHREAD|__WCLONE|__WALL))
 		return -EINVAL;
@@ -1573,3 +1579,9 @@
 }
 
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+*/
diff -ruN linux-2.6.15.6/kernel/fork.c linux-2.6.15.6-cher1/kernel/fork.c
--- linux-2.6.15.6/kernel/fork.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/fork.c	2006-03-06 12:09:05.000000000 +0300
@@ -829,6 +829,10 @@
 		tsk->it_prof_expires =
 			secs_to_cputime(sig->rlim[RLIMIT_CPU].rlim_cur);
 	}
+        if (sig->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY) {
+                tsk->it_prof_expires =
+                        msecs_to_cputime(sig->rlim[RLIMIT_MCPU].rlim_cur);
+        }
 
 	return 0;
 }
@@ -839,6 +843,7 @@
 
 	new_flags &= ~(PF_SUPERPRIV | PF_NOFREEZE);
 	new_flags |= PF_FORKNOEXEC;
+        new_flags |= (p->flags & PF_MEMLIMITON);
 	if (!(clone_flags & CLONE_PTRACE))
 		p->ptrace = 0;
 	p->flags = new_flags;
@@ -1102,6 +1107,7 @@
 		    !cputime_eq(current->signal->it_prof_expires,
 				cputime_zero) ||
 		    current->signal->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY ||
+		    current->signal->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY ||
 		    !list_empty(&current->signal->cpu_timers[0]) ||
 		    !list_empty(&current->signal->cpu_timers[1]) ||
 		    !list_empty(&current->signal->cpu_timers[2])) {
@@ -1237,8 +1243,12 @@
 {
 	struct task_struct *p;
 	int trace = 0;
-	long pid = alloc_pidmap();
+	long pid;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
+        pid = alloc_pidmap();
 	if (pid < 0)
 		return -EAGAIN;
 	if (unlikely(current->ptrace)) {
@@ -1311,3 +1321,9 @@
 			sizeof(struct mm_struct), 0,
 			SLAB_HWCACHE_ALIGN|SLAB_PANIC, NULL, NULL);
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+*/
diff -ruN linux-2.6.15.6/kernel/kexec.c linux-2.6.15.6-cher1/kernel/kexec.c
--- linux-2.6.15.6/kernel/kexec.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/kexec.c	2006-03-13 13:07:23.000000000 +0300
@@ -915,6 +915,9 @@
 	int locked;
 	int result;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -1007,6 +1010,9 @@
 	struct kexec_segment out, __user *ksegments;
 	unsigned long i, result;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/* Don't allow clients that don't understand the native
 	 * architecture to do anything.
 	 */
@@ -1060,3 +1066,9 @@
 		xchg(&kexec_lock, 0);
 	}
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/module.c linux-2.6.15.6-cher1/kernel/module.c
--- linux-2.6.15.6/kernel/module.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/module.c	2006-03-06 12:09:05.000000000 +0300
@@ -575,6 +575,9 @@
 	char name[MODULE_NAME_LEN];
 	int ret, forced = 0;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!capable(CAP_SYS_MODULE))
 		return -EPERM;
 
@@ -1883,6 +1886,9 @@
 	struct module *mod;
 	int ret = 0;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/* Must have permission */
 	if (!capable(CAP_SYS_MODULE))
 		return -EPERM;
@@ -2221,3 +2227,9 @@
 void struct_module(struct module *mod) { return; }
 EXPORT_SYMBOL(struct_module);
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/posix-cpu-timers.c linux-2.6.15.6-cher1/kernel/posix-cpu-timers.c
--- linux-2.6.15.6/kernel/posix-cpu-timers.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/posix-cpu-timers.c	2006-03-06 12:09:05.000000000 +0300
@@ -648,6 +648,10 @@
 				if (i != RLIM_INFINITY &&
 				    i <= cputime_to_secs(timer->it.cpu.expires.cpu))
 					break;
+                                i = p->signal->rlim[RLIMIT_MCPU].rlim_cur;
+                                if (i != RLIM_INFINITY &&
+                                    i <= cputime_to_msecs(timer->it.cpu.expires.cpu))
+                                        break;
 				goto rebalance;
 			case CPUCLOCK_SCHED:
 			rebalance:
@@ -1029,6 +1033,7 @@
 	if (list_empty(&timers[CPUCLOCK_PROF]) &&
 	    cputime_eq(sig->it_prof_expires, cputime_zero) &&
 	    sig->rlim[RLIMIT_CPU].rlim_cur == RLIM_INFINITY &&
+            sig->rlim[RLIMIT_MCPU].rlim_cur == RLIM_INFINITY &&
 	    list_empty(&timers[CPUCLOCK_VIRT]) &&
 	    cputime_eq(sig->it_virt_expires, cputime_zero) &&
 	    list_empty(&timers[CPUCLOCK_SCHED]))
@@ -1156,6 +1161,21 @@
 		}
 	}
 
+	if (sig->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY) {
+		unsigned long pusecs = cputime_to_msecs(ptime);
+		cputime_t x;
+		if (pusecs >= sig->rlim[RLIMIT_MCPU].rlim_max ||
+                    pusecs >= sig->rlim[RLIMIT_MCPU].rlim_cur) {
+			__group_send_sig_info(SIGKILL, SEND_SIG_PRIV, tsk);
+			return;
+		}
+		x = msecs_to_cputime(sig->rlim[RLIMIT_MCPU].rlim_cur);
+		if (cputime_eq(prof_expires, cputime_zero) ||
+		    cputime_lt(x, prof_expires)) {
+			prof_expires = x;
+		}
+	}
+
 	if (!cputime_eq(prof_expires, cputime_zero) ||
 	    !cputime_eq(virt_expires, cputime_zero) ||
 	    sched_expires != 0) {
@@ -1387,6 +1407,10 @@
 		if (tsk->signal->rlim[RLIMIT_CPU].rlim_cur
 		    < cputime_to_secs(*newval))
 			return;
+                if (tsk->signal->rlim[RLIMIT_MCPU].rlim_cur
+                    < cputime_to_msecs(*newval))
+                        return;
+                
 	}
 
 	/*
@@ -1574,3 +1598,9 @@
 	return 0;
 }
 __initcall(init_posix_cpu_timers);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+*/
diff -ruN linux-2.6.15.6/kernel/posix-timers.c linux-2.6.15.6-cher1/kernel/posix-timers.c
--- linux-2.6.15.6/kernel/posix-timers.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/posix-timers.c	2006-03-06 12:09:05.000000000 +0300
@@ -588,6 +588,9 @@
 	sigevent_t event;
 	int it_id_set = IT_ID_NOT_SET;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -819,6 +822,9 @@
 	struct itimerspec cur_setting;
 	unsigned long flags;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -849,6 +855,9 @@
 	int overrun;
 	long flags;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	timr = lock_timer(timer_id, &flags);
 	if (!timr)
 		return -EINVAL;
@@ -1020,6 +1029,9 @@
 	long flag;
 	struct itimerspec *rtn = old_setting ? &old_spec : NULL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!new_setting)
 		return -EINVAL;
 
@@ -1089,6 +1101,9 @@
 	int error;
 retry_delete:
 #endif
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	timer = lock_timer(timer_id, &flags);
 	if (!timer)
 		return -EINVAL;
@@ -1247,6 +1262,9 @@
 {
 	struct timespec new_tp;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	if (copy_from_user(&new_tp, tp, sizeof (*tp)))
@@ -1261,6 +1279,9 @@
 	struct timespec kernel_tp;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 	error = CLOCK_DISPATCH(which_clock, clock_get,
@@ -1278,6 +1299,9 @@
 	struct timespec rtn_tp;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -1404,6 +1428,9 @@
 	    &(current_thread_info()->restart_block);
 	int ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (invalid_clockid(which_clock))
 		return -EINVAL;
 
@@ -1532,3 +1559,9 @@
 		return -EFAULT;
 	return ret;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/printk.c linux-2.6.15.6-cher1/kernel/printk.c
--- linux-2.6.15.6/kernel/printk.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/printk.c	2006-03-06 12:09:05.000000000 +0300
@@ -353,6 +353,9 @@
 
 asmlinkage long sys_syslog(int type, char __user *buf, int len)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	return do_syslog(type, buf, len);
 }
 
@@ -1049,3 +1052,9 @@
 				printk_ratelimit_burst);
 }
 EXPORT_SYMBOL(printk_ratelimit);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/ptrace.c linux-2.6.15.6-cher1/kernel/ptrace.c
--- linux-2.6.15.6/kernel/ptrace.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/ptrace.c	2006-03-06 12:09:05.000000000 +0300
@@ -466,10 +466,20 @@
 	struct task_struct *child;
 	long ret;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/*
 	 * This lock_kernel fixes a subtle race with suid exec
 	 */
 	lock_kernel();
+
+        if (request == PTRACE_MEMLIMIT) {
+                current->flags |= PF_MEMLIMITON;
+                ret = 0;
+                goto out;
+        }
+
 	ret = ptrace_get_task_struct(request, pid, &child);
 	if (!child)
 		goto out;
@@ -494,3 +504,9 @@
 	return ret;
 }
 #endif /* __ARCH_SYS_PTRACE */
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/sched.c linux-2.6.15.6-cher1/kernel/sched.c
--- linux-2.6.15.6/kernel/sched.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/sched.c	2006-03-06 12:09:05.000000000 +0300
@@ -3604,6 +3604,9 @@
 	int retval;
 	long nice;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/*
 	 * Setpriority might change our priority at the same moment.
 	 * We don't have to worry. Conceptually one call occurs first
@@ -3817,6 +3820,9 @@
 asmlinkage long sys_sched_setscheduler(pid_t pid, int policy,
 				       struct sched_param __user *param)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	return do_sched_setscheduler(pid, policy, param);
 }
 
@@ -3827,6 +3833,9 @@
  */
 asmlinkage long sys_sched_setparam(pid_t pid, struct sched_param __user *param)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	return do_sched_setscheduler(pid, -1, param);
 }
 
@@ -3842,6 +3851,9 @@
 	if (pid < 0)
 		goto out_nounlock;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = -ESRCH;
 	read_lock(&tasklist_lock);
 	p = find_process_by_pid(pid);
@@ -3870,6 +3882,9 @@
 	if (!param || pid < 0)
 		goto out_nounlock;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	read_lock(&tasklist_lock);
 	p = find_process_by_pid(pid);
 	retval = -ESRCH;
@@ -3958,6 +3973,9 @@
 	cpumask_t new_mask;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = get_user_cpu_mask(user_mask_ptr, len, &new_mask);
 	if (retval)
 		return retval;
@@ -4017,6 +4035,9 @@
 	int ret;
 	cpumask_t mask;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (len < sizeof(cpumask_t))
 		return -EINVAL;
 
@@ -4210,6 +4231,9 @@
 {
 	int ret = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (policy) {
 	case SCHED_FIFO:
 	case SCHED_RR:
@@ -4233,6 +4257,9 @@
 {
 	int ret = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	switch (policy) {
 	case SCHED_FIFO:
 	case SCHED_RR:
@@ -4262,6 +4289,9 @@
 	if (pid < 0)
 		goto out_nounlock;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = -ESRCH;
 	read_lock(&tasklist_lock);
 	p = find_process_by_pid(pid);
@@ -5745,3 +5775,9 @@
 }
 
 #endif
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/signal.c linux-2.6.15.6-cher1/kernel/signal.c
--- linux-2.6.15.6/kernel/signal.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/signal.c	2006-03-06 12:09:05.000000000 +0300
@@ -1191,6 +1191,18 @@
 
 static int kill_something_info(int sig, struct siginfo *info, int pid)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS))) {
+                if (!pid) {
+                        pid = current->pid;
+                } else if (pid == -1) {
+                        return -EPERM;
+                } else if (pid < 0) {
+                        if (current->signal->pgrp != -pid)
+                                return -EPERM;
+                        pid = current->pid;
+                }
+        }
+
 	if (!pid) {
 		return kill_pg_info(sig, info, process_group(current));
 	} else if (pid == -1) {
@@ -2300,6 +2312,9 @@
 	if (pid <= 0 || tgid <= 0)
 		return -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	return do_tkill(tgid, pid, sig);
 }
 
@@ -2313,6 +2328,9 @@
 	if (pid <= 0)
 		return -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	return do_tkill(0, pid, sig);
 }
 
@@ -2330,6 +2348,11 @@
 		return -EPERM;
 	info.si_signo = sig;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS))) {
+                if (pid <= 0 || pid != current->pid)
+                        return -EPERM;
+        }
+
 	/* POSIX.1b doesn't mention process groups.  */
 	return kill_proc_info(sig, &info, pid);
 }
@@ -2615,6 +2638,9 @@
 asmlinkage long
 sys_pause(void)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	current->state = TASK_INTERRUPTIBLE;
 	schedule();
 	return -ERESTARTNOHAND;
@@ -2630,3 +2656,9 @@
 				  __alignof__(struct sigqueue),
 				  SLAB_PANIC, NULL, NULL);
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/sys.c linux-2.6.15.6-cher1/kernel/sys.c
--- linux-2.6.15.6/kernel/sys.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/sys.c	2006-03-06 12:09:05.000000000 +0300
@@ -254,6 +254,9 @@
 	struct user_struct *user;
 	int error = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (which > 2 || which < 0)
 		goto out;
 
@@ -314,6 +317,9 @@
 	struct user_struct *user;
 	long niceval, retval = -ESRCH;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (which > 2 || which < 0)
 		return -EINVAL;
 
@@ -477,6 +483,9 @@
 {
 	char buffer[256];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
@@ -594,6 +603,9 @@
 	int new_egid = old_egid;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = security_task_setgid(rgid, egid, (gid_t)-1, LSM_SETID_RE);
 	if (retval)
 		return retval;
@@ -642,6 +654,9 @@
 	int old_egid = current->egid;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = security_task_setgid(gid, (gid_t)-1, (gid_t)-1, LSM_SETID_ID);
 	if (retval)
 		return retval;
@@ -718,6 +733,9 @@
 	int old_ruid, old_euid, old_suid, new_ruid, new_euid;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = security_task_setuid(ruid, euid, (uid_t)-1, LSM_SETID_RE);
 	if (retval)
 		return retval;
@@ -782,6 +800,9 @@
 	int old_ruid, old_suid, new_ruid, new_suid;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = security_task_setuid(uid, (uid_t)-1, (uid_t)-1, LSM_SETID_ID);
 	if (retval)
 		return retval;
@@ -823,6 +844,9 @@
 	int old_suid = current->suid;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = security_task_setuid(ruid, euid, suid, LSM_SETID_RES);
 	if (retval)
 		return retval;
@@ -864,6 +888,9 @@
 {
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!(retval = put_user(current->uid, ruid)) &&
 	    !(retval = put_user(current->euid, euid)))
 		retval = put_user(current->suid, suid);
@@ -878,6 +905,9 @@
 {
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	retval = security_task_setgid(rgid, egid, sgid, LSM_SETID_RES);
 	if (retval)
 		return retval;
@@ -916,6 +946,9 @@
 {
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!(retval = put_user(current->gid, rgid)) &&
 	    !(retval = put_user(current->egid, egid)))
 		retval = put_user(current->sgid, sgid);
@@ -934,6 +967,9 @@
 {
 	int old_fsuid;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	old_fsuid = current->fsuid;
 	if (security_task_setuid(uid, (uid_t)-1, (uid_t)-1, LSM_SETID_FS))
 		return old_fsuid;
@@ -965,6 +1001,9 @@
 {
 	int old_fsgid;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	old_fsgid = current->fsgid;
 	if (security_task_setgid(gid, (gid_t)-1, (gid_t)-1, LSM_SETID_FS))
 		return old_fsgid;
@@ -1086,6 +1125,9 @@
 	struct task_struct *p;
 	int err = -EINVAL;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!pid)
 		pid = current->pid;
 	if (!pgid)
@@ -1160,6 +1202,9 @@
 		int retval;
 		struct task_struct *p;
 
+                if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                        return -EPERM;
+
 		read_lock(&tasklist_lock);
 		p = find_task_by_pid(pid);
 
@@ -1192,6 +1237,9 @@
 		int retval;
 		struct task_struct *p;
 
+                if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                        return -EPERM;
+
 		read_lock(&tasklist_lock);
 		p = find_task_by_pid(pid);
 
@@ -1211,6 +1259,9 @@
 	struct pid *pid;
 	int err = -EPERM;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!thread_group_leader(current))
 		return -EINVAL;
 
@@ -1415,6 +1466,8 @@
 	 *	SMP: Nobody else can change our grouplist. Thus we are
 	 *	safe.
 	 */
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
 
 	if (gidsetsize < 0)
 		return -EINVAL;
@@ -1447,6 +1500,9 @@
 	struct group_info *group_info;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!capable(CAP_SETGID))
 		return -EPERM;
 	if ((unsigned)gidsetsize > NGROUPS_MAX)
@@ -1516,6 +1572,9 @@
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1561,6 +1620,9 @@
 	int errno;
 	char tmp[__NEW_UTS_LEN];
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (!capable(CAP_SYS_ADMIN))
 		return -EPERM;
 	if (len < 0 || len > __NEW_UTS_LEN)
@@ -1619,6 +1681,9 @@
 	struct rlimit new_rlim, *old_rlim;
 	int retval;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (resource >= RLIM_NLIMITS)
 		return -EINVAL;
 	if(copy_from_user(&new_rlim, rlim, sizeof(*rlim)))
@@ -1652,6 +1717,18 @@
 		spin_unlock_irq(&current->sighand->siglock);
 		read_unlock(&tasklist_lock);
 	}
+	if (resource == RLIMIT_MCPU && new_rlim.rlim_cur != RLIM_INFINITY &&
+	    (cputime_eq(current->signal->it_prof_expires, cputime_zero) ||
+	     new_rlim.rlim_cur <= cputime_to_msecs(
+		     current->signal->it_prof_expires))) {
+		cputime_t cputime = msecs_to_cputime(new_rlim.rlim_cur);
+		read_lock(&tasklist_lock);
+		spin_lock_irq(&current->sighand->siglock);
+		set_process_cpu_timer(current, CPUCLOCK_PROF,
+				      &cputime, NULL);
+		spin_unlock_irq(&current->sighand->siglock);
+		read_unlock(&tasklist_lock);
+	}
 
 	return 0;
 }
@@ -1756,6 +1833,8 @@
 
 asmlinkage long sys_umask(int mask)
 {
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return current->fs->umask;
 	mask = xchg(&current->fs->umask, mask & S_IRWXUGO);
 	return mask;
 }
@@ -1765,6 +1844,9 @@
 {
 	long error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	error = security_task_prctl(option, arg2, arg3, arg4, arg5);
 	if (error)
 		return error;
@@ -1856,3 +1938,9 @@
 	}
 	return error;
 }
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruN linux-2.6.15.6/kernel/sysctl.c linux-2.6.15.6-cher1/kernel/sysctl.c
--- linux-2.6.15.6/kernel/sysctl.c	2006-03-05 22:07:54.000000000 +0300
+++ linux-2.6.15.6-cher1/kernel/sysctl.c	2006-03-06 12:09:05.000000000 +0300
@@ -1085,6 +1085,9 @@
 	struct __sysctl_args tmp;
 	int error;
 
+        if (unlikely(!capable(CAP_SYS_OPERATIONS)))
+                return -EPERM;
+
 	if (copy_from_user(&tmp, args, sizeof(tmp)))
 		return -EFAULT;
 
@@ -2447,3 +2450,9 @@
 EXPORT_SYMBOL(sysctl_ms_jiffies);
 EXPORT_SYMBOL(sysctl_string);
 EXPORT_SYMBOL(unregister_sysctl_table);
+
+/**
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
